film/urls.py
from django.urls import path

from . import views

app_name = 'film'

urlpatterns = [
    # path('', views.index, name='list'),
    path('', views.FilmView.as_view(), name='list'),
    # path('detail/<int:pk>', views.detail, name='detail'),
    path('detail/<int:pk>', views.FilmDetailView.as_view(), name='detail'),
    # path('create-form/', views.create_form, name='list'),
    path('create-form/', views.AddFilmView.as_view(), name='add'),
    # path('edit-form/<int:pk>', views.edit_form, name='list'),
    path('edit-form/<int:pk>', views.UpdateFilmView.as_view(), name='update'),

    path('delete/<int:pk>', views.DeleteFilmView.as_view(), name = 'delete')
]

forum/urls.py
from django.contrib import admin
from django.urls import path
from . import views

app_name = 'forum'

urlpatterns = [
    path('forum/<int:id>',views.forum_view, name='forum_view'),
    path('add-new-topic-forum/<int:id>',views.add_new_topic_forum, name='add_new_topic_forum'),
    path('view-replies/<int:id>/<int:idForum>',views.forum_view_replies, name='view-replies'),
    path('del-forum/<int:id>',views.delete_forum, name='del-forum'),
    path('del-reply/<int:id>',views.delete_reply, name='del-reply'),

]

sipi/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf.urls.static import static
from django.conf import settings


urlpatterns = [
    path('admin/', admin.site.urls),
    path('berita/', include('berita.urls')),
    path('ulasan/', include('ulasan.urls')),
    path('', include('home.urls')),
    path('', include('watchlist.urls')),
    path('', include('forum.urls')),
    path('film/', include('film.urls')),
    path('account/', include('account.urls')),
]

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

forum/models.py
from django.db import models
from django.conf import settings
from film.models import Film
from django.utils import timezone

User = settings.AUTH_USER_MODEL
# Create your models here.

class Forum(models.Model):
	film = models.ForeignKey(Film, blank=True, null=True, on_delete=models.CASCADE)
	user = models.ForeignKey(User, blank=True, on_delete=models.CASCADE)
	topik = models.CharField(max_length=200, blank=True)
	isi = models.TextField(max_length=500, null=True, blank=True)
	tanggal = models.DateTimeField(default=timezone.now)

	def __str__(self):
		return self.topik

class Reply(models.Model):
	user = models.ForeignKey(User, blank=True, on_delete=models.CASCADE)
	forum = models.ForeignKey(Forum, blank=True, on_delete=models.CASCADE)
	isi = models.TextField(max_length=500, null=True, blank=True)
	tanggal = models.DateTimeField(default=timezone.now)

	def __str__(self):
		return self.user.username + ": " + self.forum.topik
	class Meta:
		db_table = 'reply'
		verbose_name_plural = "replies"

forum/forms.py
from django import forms
from .models import *

class ForumForm(forms.ModelForm):
	isi = forms.CharField(max_length=500, widget=forms.Textarea, required=False)
	topik = forms.CharField(max_length=200, required=True)
	class Meta:
		model = Forum
		fields = ['topik', 'isi']

class ReplyForm(forms.ModelForm):
	isi = forms.CharField(max_length=500, widget=forms.Textarea, required=True)

	class Meta:
		model = Reply
		fields = ['isi']

forum/views.py
from django.shortcuts import render, redirect
from django.contrib import messages
from .forms import *
from .models import *
from film.models import Film
from django.contrib.auth.decorators import login_required

# Create your views here.
def forum_view(request, id):
	film = Film.objects.get(id=id)
	forum = film.forum_set.all()
	context ={'film': film, 'forums': forum}
	return render(request, 'forum_detail.html', context)

@login_required(login_url='account:login')
def add_new_topic_forum(request, id):
	form = ForumForm()
	film = Film.objects.get(id=id)
	context={'id': id, 'form': form, 'film': film}
	if(request.POST):
		data = request.POST
		form = ForumForm(request.POST)
		if form.is_valid():
			Forum.objects.create(user=request.user, film=film, topik=data['topik'], isi=data['isi'])
			messages.add_message(request, messages.INFO,'Forum has been created')
			return redirect('forum:forum_view', id=id)
	else:
		context['form'] = ForumForm()
	return render(request, 'add_new_topic_forum.html', context)


def forum_view_replies(request, id, idForum):
	form = ReplyForm()
	forum = Forum.objects.get(id=idForum)
	film = Film.objects.get(id=id)
	replies = forum.reply_set.all()
	context = {'idFilm': id, 'idForum': idForum, 'form': form, 'film': film, 'replies': replies, 'forum': forum}
	if(request.POST and request.user.is_authenticated):
		data = request.POST
		form = ReplyForm(request.POST)
		if form.is_valid():
			forum = Forum.objects.get(id=idForum)
			Reply.objects.create(user=request.user, forum=forum, isi=data['isi'])
			messages.add_message(request, messages.INFO,'Reply has been added')
			return redirect('forum:view-replies', id=id, idForum=idForum)
	else:
		context['form'] = ReplyForm()
	return render(request, 'forum_replies.html', context)

@login_required(login_url='account:login')
def delete_forum(request, id):
	forum = Forum.objects.get(id=id)
	idFilm = forum.film.id
	forum.delete()
	messages.add_message(request, messages.INFO,'Forum has been deleted')
	return redirect('forum:forum_view', id=idFilm)

@login_required(login_url='account:login')
def delete_reply(request, id):
	reply = Reply.objects.get(id=id)
	idFilm = reply.forum.film.id
	idForum = reply.forum.id
	reply.delete()
	messages.add_message(request, messages.INFO,'Reply has been deleted')
	return redirect('forum:view-replies', id=idFilm, idForum=idForum)

forum/templates/add_new_topic_forum.html
{% extends 'base.html' %}
{% load static %}
{% block css %}
<link rel="stylesheet" type="text/css" href="{% static 'css/form_forum.css' %}">
{% endblock css %}
{% block title %}
Forum
{% endblock title %}
{% block content %}
<section id="form-forum-section" style="margin-top: 20px">
    <div class="form-wrapper">
        <div class="form-top">
            <div id="title-form">
                <h1>Tambahkan Topik Baru</h1>
            </div>
            <div id="judul-film">
                <span>Judul Film: {{ film.judul }}</span>
            </div>
        </div>
        <hr>
        <div class="form-body">
            <form id="form" method="POST" action="{% url 'forum:add_new_topic_forum' id=film.id %}">
                {% csrf_token %}
                {% for field in form %}
                <div class="form-field">
                        {{ field.label_tag }}<br>
                        {{ field }}<br>
                        {% for error in field.errors %}
                        <small style="color:red;">{{error}}</small><br>
                        {% endfor %}
                </div>
                {% endfor %}
                <div id="button-form">
                    <button class="btn btn-outline-secondary btn-sm" value="submit" type="submit"> Submit</button>
                    <a class="btn btn-danger btn-sm" value={{film.id}} onclick="myFunction(this)">Cancel</a>
                </div>
            </form>
        </div>
    </div>
</section>
{% endblock content %}
{% block script %}
<script>
    function myFunction(e) {
    var id = e.getAttribute("value");
    if (confirm("Are you sure want to cancel?")) {
        window.location.href = "/forum/" + id;
    }
}


let doc = document.getElementsByTagName('input')
for (let field in doc)
    doc[field].className += "form-control"

</script>
{% endblock script %}

forum/templates/forum_detail.html
{% extends 'base.html' %}
{% load static %}
{% block css %}
<link rel="stylesheet" type="text/css" href="{% static 'css/forum_detail.css' %}">
{% endblock css %}
{% block title %}
Forum
{% endblock title %}
{% block content %}
<section id="forum-section" style="margin-top: 20px">
    {% for message in messages %}
    <div class="alert hidden" id="{{message.tags}}" value="{{message}}" role="alert">{{message}}</div>
    {% endfor %}
    <div class="forum-section-heading">
        <!-- MODAL -->
        <div class="modal fade" id="exampleModal" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="exampleModalLabel">Konfirmasi</h5>
                        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                    </div>
                    <div class="modal-body">
                        <p>Apakah anda yakin ingin menghapus topik ini dari forum?</p>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Batalkan</button>
                        <button type="button" class="btn btn-primary" onclick="del()">Hapus</button>
                    </div>
                </div>
            </div>
        </div>
        <!-- HEADING -->
        <span>Forum</span>
        <h1>{{ film.judul_film }}</h1>
    </div>
    <a type="button" class="button" value={{film.id}} onclick="addTopic(this)"  user-data={{request.user}}>
        <span class="button__text">Add New Topic</span>
        <span class="button__icon">
            <i class="fas fa-plus"></i>
        </span>
    </a>
    <!-- BOX FORUM CONTAINER -->
    <div class="forum-box-container">
        <!-- BOX -->
        {% for forum in forums %}
        <div class="forum-box">
            <!-- TOP -->
            <div class="box-top">
                <!-- TOPIC -->
                <div class="topic">
                    <div class="topic-link">
                        <a href="{% url 'forum:view-replies' id=film.id idForum=forum.id %}"><strong>{{ forum.topik }}</strong></a>
                    </div>
                </div>
                <!-- USERNAME -->
                <div id="profile">
                    <div id="user-name">
                        <span><em>started by: {{ forum.user.username }}</em></span>
                    </div>
                    <div id="tanggal">
                        <span><em>posted on: {{ forum.tanggal }}</em></span>
                    </div>
                </div>
            </div>
            <hr>
            <!-- ISI -->
            <div class="description">
                <p>{{ forum.isi }}</p>
            </div>
            {% if request.user.is_authenticated and request.user == forum.user %}
            <div class="button-del">
                <a data-bs-toggle="modal" id="del-btn" data-bs-target="#exampleModal" href="{% url 'forum:del-forum' id=forum.id %}">Hapus</a>
            </div>
            {% endif %}
        </div>
        {% endfor %}
    </div>
</section>
{% endblock content %}
{% block script %}
<script type="text/javascript">
function del() {
    let btn = document.getElementById("del-btn")

    window.location.href = btn.getAttribute("href")
}


function addTopic(e){
    let id = e.getAttribute("value");
    if(e.getAttribute("user-data") == "AnonymousUser"){
        alertUser()
    }
    else{
        window.location.href = "/add-new-topic-forum/" + id;
    }
}

function alertUser() {
    setTimeout(function() {
        $.bootstrapGrowl("Please Log In", {
            type: "danger",
            align: 'center',
            width: 'auto',
            allow_dismiss: false
        })
    }, 50)

}
</script>
{% endblock script %}

forum/templates/forum_replies.html
{% extends 'base.html' %}
{% load static %}
{% block css %}
<link rel="stylesheet" type="text/css" href="{% static 'css/forum_replies.css' %}">
{% endblock css %}
{% block title %}
Forum
{% endblock title %}
{% block content %}
<section id="forum-section" style="margin-top: 10px;">
    <!-- BOX FORUM CONTAINER -->
    <div class="main-box-container">
        {% for message in messages %}
        <div class="alert hidden" id="{{message.tags}}" value="{{message}}" role="alert">{{message}}</div>
        {% endfor %}
        <!-- MODAL -->
        <div class="modal fade" id="exampleModal" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="exampleModalLabel">Konfirmasi</h5>
                        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                    </div>
                    <div class="modal-body">
                        <p>Apakah anda yakin ingin menghapus balasan ini?</p>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Batalkan</button>
                        <button type="button" class="btn btn-primary" onclick="del()">Hapus</button>
                    </div>
                </div>
            </div>
        </div>
        <!-- BOX -->
        <div class="forum-box">
            <!-- TOP -->
            <div class="box-top">
                <!-- TOPIC -->
                <div class="topic">
                    <div class="topic-link">
                        <a href="{% url 'forum:view-replies' id=idFilm idForum=idForum %}"><strong>{{ forum.topik }}</strong></a>
                    </div>
                </div>
                <!-- USERNAME -->
                <div id="profile">
                    <div id="user-name">
                        <span><em>started by: {{ forum.user.username }}</em></span>
                    </div>
                    <div id="tanggal">
                        <span><em>posted on: {{ forum.tanggal }}</em></span>
                    </div>
                </div>
            </div>
            <hr>
            <!-- ISI -->
            <div class="description">
                <p>{{ forum.topik }}</p>
            </div>
            <div class="button-reply">
                <a class="btn btn-outline-success btn-sm" href="{% url 'forum:forum_view' id=idFilm %}" type="button" role="button">Back</a>
                <a class="btn btn-outline-success btn-sm" value={{request.user}} onclick="showForm(this)" type="button" role="button">Reply</a>
            </div>
        </div>
    </div>
    <div class="box-replies-container">
        <div class="reply-title">
            <h2>Replies</h2>
        </div>
        <!-- REPLY -->
        {% for reply in replies %}
        <div class="reply-box">
            <!-- TOP -->
            <div class="box-top-reply">
                <!-- USERNAME -->
                <div id="profile-reply">
                    <div id="user-name-reply">
                        <span><em>user: {{ reply.user.username }}</em></span>
                    </div>
                    <div id="tanggal-reply">
                        <span><em>posted on: {{ reply.tanggal }}</em></span>
                    </div>
                </div>
            </div>
            <hr>
            <!-- ISI -->
            <div class="isi-reply">
                <p>{{ reply.isi }}</p>
            </div>
            {% if request.user.is_authenticated and request.user == reply.user %}
            <div class="button-del">
                <a data-bs-toggle="modal" id="del-btn" data-bs-target="#exampleModal" href="{% url 'forum:del-reply' id=reply.id %}">Hapus</a>
            </div>
            {% endif %}
        </div>
        {% endfor %}
        <div class="form-replies" id="form-reply">
            <div id="form-replies-wrapper" class="form-wrapper hidden">
                <div class="form-top">
                    <div id="title-form">
                        <h1>Reply</h1>
                    </div>
                </div>
                <hr>
                <div class="form-body">
                    <form id="form" method="POST" action="{% url 'forum:view-replies' id=idFilm idForum=idForum %}">
                        {% csrf_token %}
                        {% for field in form %}
                        <div class="form-field">
                            {{ field }}<br>
                            {% for error in field.errors %}
                            <small style="color:red;">{{error}}</small><br>
                            {% endfor %}
                        </div>
                        {% endfor %}
                        <div id="button-form">
                            <button class="btn btn-outline-secondary btn-sm" value="submit" type="submit"> Submit</button>
                            <a class="btn btn-danger btn-sm" id="cancel-reply" onclick="myFunction()">Cancel</a>
                        </div>
                    </form>
                </div>
            </div>
        </div>
        <div class="back-top">
            <button type="button" class="btn btn-danger btn-floating btn-lg" id="myBtn" onclick="backToTop()">
                <i class="fas fa-arrow-up"></i>
            </button>
        </div>
    </div>
</section>
{% endblock content %}
{% block script %}
<!-- <script type="text/javascript">

            $(function() {
                
                setTimeout(function() {
                    $.bootstrapGrowl("Danger, Danger!", {
                        type: 'danger',
                        align: 'center',
                        width: 'auto',
                        allow_dismiss: false
                    });
                }, 2000);
                
            });

        </script> -->
<script>
let mybutton = document.getElementById("myBtn");

// When the user scrolls down 20px from the top of the document, show the button
window.onscroll = function() {
    scrollFunction();
};

function scrollFunction() {
    if (
        document.body.scrollTop > 20 ||
        document.documentElement.scrollTop > 20
    ) {
        mybutton.style.display = "block";
    } else {
        mybutton.style.display = "none";

    }
}
// When the user clicks on the button, scroll to the top of the document
mybutton.addEventListener("click", backToTop);

function backToTop() {
    document.body.scrollTop = 0;
    document.documentElement.scrollTop = 0;
    setTimeout(() => {
        hideForm();
    }, 500);
}



function myFunction() {
    if (confirm("Are you sure want to cancel?")) {
        backToTop();
    }
}


function showForm(e) {
    let wrapper = document.getElementById("form-replies-wrapper");
    user = e.getAttribute("value")
    if (user != "AnonymousUser") {
        wrapper.classList.remove("hidden");
        document.getElementById("form-reply").scrollIntoView();
    }
    else{
       alertUser()
    }
}

function alertUser() {
    setTimeout(function() {
        $.bootstrapGrowl("Please Log In", {
            type: "danger",
            align: 'center',
            width: 'auto',
            allow_dismiss: false
        })
    }, 1000)

}

function hideForm() {
    let wrapper = document.getElementById("form-replies-wrapper");
    wrapper.classList.add("hidden");
}


function del() {
    let btn = document.getElementById("del-btn")

    window.location.href = btn.getAttribute("href")
}
</script>
{% endblock script %}